(* $Id: topfind.mli,v 1.1 1999/06/26 15:45:18 gerd Exp $
 * ----------------------------------------------------------------------
 *
 *)

(* Load packages from toploops (scripts) *)

(* Note: This library is not thread-safe. Loading of packages should always
 * have occured before execution threads fork.
 *)

val predicates : string list ref
  (* The list of predicates used for package loading *)

val don't_load : string list -> unit
  (* don't_load pkglist:
   * 
   * The packages named in pkglist are added to the list of packages which
   * are already loaded.
   *)

val don't_load_deeply : string list -> unit
  (* don't_load_deeply pkglist:
   * 
   * The packages named in pkglist and all direct and indirect ancestors
   * are added to the list of packages which are already loaded.
   *)

val load : string list -> unit
  (* load pkglist:
   *
   * The packages from pkglist are loaded, from left to right, but packages
   * that have already been loaded are left out.
   *)

val load_deeply : string list -> unit
  (* load_deeply pkglist:
   * 
   * The packages from pkglist and all direct or indirect ancestors are loaded
   * in topological order. Packages that have already been loaded are left
   * out.
   *)

val reset : unit -> unit
  (* All entries in the list of loaded packages that have been added by 
   * 'load' or 'load_deeply' functions are removed from this list. This
   * means that if you execute the same 'load' or 'load_deeply' functions
   * again, the packages will be reloaded.
   *)

(* ======================================================================
 * History:
 * 
 * $Log: topfind.mli,v $
 * Revision 1.1  1999/06/26 15:45:18  gerd
 * 	Initial revision.
 *
 * 
 *)
